/**************************************************************
** 	mili
**	LCD
**  汾V1.0  
**	̳www.openmcu.com
**	Աhttp://shop36995246.taobao.com/   
**  ֧Ⱥ105339839 
***************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "hardware.h"
#include "ili932x.h"

unsigned int  HDP=479;

unsigned int  HT=531;
unsigned int  HPS=43;
unsigned int  LPS=8;
unsigned char HPW=10;

unsigned int  VDP=271;



unsigned int  VT=288;
unsigned int  VPS=12;
unsigned int  FPS=4;
unsigned char   VPW=10;

uint32_t POINT_COLOR = BLUE,BACK_COLOR = WHITE;  /* ֱõɫ͵ɫ	*/

/*****************************************************************************
** : LCD_Write_Reg
** : дָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_WriteReg(uint16_t LCD_Reg,uint16_t LCD_Dat)
{
	Write_Cmd(LCD_Reg);
	Write_Dat(LCD_Dat);
}
/*****************************************************************************
** : Write_Cmd
** : дָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Write_Cmd(uint16_t LCD_Reg)
{
	LCD_CS = 0;
	LCD_RS = 0;
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Reg&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Reg&0xff00); 
	LCD_WR = 0;
	LCD_WR = 1;	
	LCD_CS = 1;
}
/*****************************************************************************
** : Write_Dat
** : д
**   : Dream
** ա  : 20101206
*****************************************************************************/
void Write_Dat(uint16_t LCD_Dat)
{
	LCD_CS = 0;
	LCD_RS = 1;
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Dat&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Dat&0xff00);
	LCD_WR = 0;
	LCD_WR = 1;	
	LCD_CS = 1;
}
/*****************************************************************************
** : LCD_ReadReg
** : ָ
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t LCD_ReadReg(uint16_t LCD_Reg)
{
	uint16_t temp;
	Write_Cmd(LCD_Reg);  //дҪļĴ  

	GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x44444444; //˿ڸ8λó
	GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x44444444; //˿ڵ8λó  
	LCD_CS = 0;
	LCD_RS = 1;
	LCD_RD = 0;
	temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff)); //ȡ(Ĵʱ,Ҫ2) 	
	LCD_RD = 1;
	LCD_CS = 1; 
	GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x33333333; //ͷŶ˿ڸ8λΪ
	GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x33333333; //ͷŶ˿ڵ8λΪ
	return temp;   
}
/*****************************************************************************
** : LCD_ReadDat
** : 
**   : Dream
** ա  : 20101206
*****************************************************************************/
uint16_t LCD_ReadDat()
{
	uint16_t temp;

	GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x44444444;  //˿ڸ8λó
	GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x44444444;  //˿ڵ8λó
	LCD_CS = 0;
	LCD_RS = 1;
	LCD_RD = 0;
	temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff));	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD = 1;
	LCD_CS = 1;
	GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x33333333;  //ͷŶ˿ڸ8λΪ
	GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x33333333;  //ͷŶ˿ڵ8λΪ

	return temp;   
}
/*****************************************************************************
** : LCD_Configuration
** : LCD_IO
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Configuration()
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC,ENABLE);

	/* IO ӵGPIOB *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 
								| GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	/* ÿIO ӵPD12.PD13.PD14.PD15 *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 
								| GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7 
								| GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOC, &GPIO_InitStructure);
}
/*****************************************************************************
** : LCD_Init
** : LCDʼ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Init(void)
{
	static uint16_t DeviceCode;
	LCD_Configuration();
	LCD_WriteReg(0x0000,0x0001);
	LCD_Delay(5); // LCD_Delay 50 ms 
	DeviceCode = LCD_ReadReg(0x0000);   
	printf(" ID=0x%x\n",DeviceCode); 
	///////////////////////////////////
	LCD_Delay(5); // delay 50 ms 
	Write_Cmd(0x00E2);	//PLL multiplier, set PLL clock to 120M
	Write_Dat(0x0023);	    //N=0x36 for 6.5M, 0x23 for 10M crystal
	Write_Dat(0x0002);
	Write_Dat(0x0004);
	
	Write_Cmd(0x00E0);  // PLL enable
	Write_Dat(0x0001);
	LCD_Delay(1);
	Write_Cmd(0x00E0);
	Write_Dat(0x0003);
	LCD_Delay(5);
	Write_Cmd(0x0001);  // software reset
	LCD_Delay(5);
	Write_Cmd(0x00E6);	//PLL setting for PCLK, depends on resolution
	Write_Dat(0x0001);
	Write_Dat(0x0033);
	Write_Dat(0x0032);

	Write_Cmd(0x00B0);	//LCD SPECIFICATION
	Write_Dat(0x0020);
	Write_Dat(0x0000);
	Write_Dat((HDP>>8)&0X00FF);  //Set HDP
	Write_Dat(HDP&0X00FF);
    Write_Dat((VDP>>8)&0X00FF);  //Set VDP
	Write_Dat(VDP&0X00FF);
    Write_Dat(0x0000);

	Write_Cmd(0x00B4);	//HSYNC
	Write_Dat((HT>>8)&0X00FF);  //Set HT
	Write_Dat(HT&0X00FF);
	Write_Dat((HPS>>8)&0X00FF);  //Set HPS
	Write_Dat(HPS&0X00FF);
	Write_Dat(HPW);			   //Set HPW
	Write_Dat((LPS>>8)&0X00FF);  //Set HPS
	Write_Dat(LPS&0X00FF);
	Write_Dat(0x0000);

	Write_Cmd(0x00B6);	//VSYNC
	Write_Dat((VT>>8)&0X00FF);   //Set VT
	Write_Dat(VT&0X00FF);
	Write_Dat((VPS>>8)&0X00FF);  //Set VPS
	Write_Dat(VPS&0X00FF);
	Write_Dat(VPW);			   //Set VPW
	Write_Dat((FPS>>8)&0X00FF);  //Set FPS
	Write_Dat(FPS&0X00FF);

	Write_Cmd(0x00BA);
	Write_Dat(0x000F);    //GPIO[3:0] out 1

	Write_Cmd(0x00B8);
	Write_Dat(0x0007);    //GPIO3=input, GPIO[2:0]=output
	Write_Dat(0x0001);    //GPIO0 normal

//	Write_Cmd(0x0036); //rotation
//	Write_Dat(0x0000);
//	Write_Dat(0x0060);
	//============================================

	//============================================
//	LCD_WR_REG(0x003A); //rotation
//	Write_Dat(0x0050);

//		Write_Cmd(0x0026); //rotation
//	Write_Dat(0x0003);
//		Write_Cmd(0x0030); //rotation
//	Write_Dat(0x0000);

	//=============================================

	//=============================================
	Write_Cmd(0x00F0); //pixel data interface
	Write_Dat(0x0002);

    Write_Cmd(0x0021);	//ͼɫתģʽ

	Write_Cmd(0x00BC);//Ҫ
	Write_Dat(0x0080);//Աȶ
	Write_Dat(0x0080);//
	Write_Dat(0x0080);//Ͷֵ  //
	Write_Dat(0x0001);//


	LCD_Clear(BLACK);

	Write_Cmd(0x0029); //display on

//	LCD_Clear(WHITE);	
}
/*****************************************************************************
** : LCD_DrawPoint
** : дһ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_DrawPoint(uint16_t x,uint16_t y)
{
	LCD_SetCursor(x,y);//ùλ 
	Write_Cmd(R34);//ʼдGRAM
	Write_Dat(POINT_COLOR); 	
}
/*****************************************************************************
** : LCD_WriteRAM_Prepare
** : Щ׼
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_WriteRAM_Prepare()
{
	Write_Cmd(R34);	
}
/*****************************************************************************
** : LCD_SetCursor
** : ù꺯
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_SetCursor(uint16_t Xpos,uint16_t Ypos)
{
	LCD_WriteReg(R32, Xpos);
	LCD_WriteReg(R33, Ypos);	
} 
/*****************************************************************************
** : LCD_Clear
** : Ļ
**   : Dream
** ա  : 20101206
*****************************************************************************/
//
//Color:Ҫɫ
void LCD_Clear(u32 color)
{
int i = 0;
    unsigned int l=480,w;
	unsigned char rcode,gcode,bcode;

	rcode = (unsigned char)(color >> 16);
	gcode = (unsigned char)(color >> 8);
	bcode = (unsigned char)color;

	Write_Cmd(0x002a);	
	Write_Dat(0);	    
	Write_Dat(0);
	Write_Dat(HDP>>8);	    
	Write_Dat(HDP&0x00ff);
    Write_Cmd(0x002b);	
	Write_Dat(0);	    
	Write_Dat(0);
	Write_Dat(VDP>>8);	    
	Write_Dat(VDP&0x00ff);
	Write_Cmd(0x002c);
	
	
	while(l--)
	{
		i = 0;
	    for(w=0;w<272;w++)
		{		
			Write_Dat((rcode << 8) | (gcode));
			Write_Dat((bcode << 8) | (rcode));
			Write_Dat((gcode << 8) | (bcode));
		}
//		while((i++)!=5000);
	} 
}  
/*****************************************************************************
** : LCD_Delay
** : LCDʱ
**   : Dream
** ա  : 20101206
*****************************************************************************/
void LCD_Delay (uint32_t nCount)
{
	__IO uint16_t i;	 	
	for (i=0;i<nCount*100;i++);
}
/*********************************************************************************************************
** End of File
*********************************************************************************************************/
